/* client.c generated by valac 0.25.1, the Vala compiler
 * generated from client.vala, do not modify */

/*
 * Copyright (C) 2012 Daiki Ueno <ueno@unixuser.org>
 * Copyright (C) 2012 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <libfep-glib/libfep-glib.h>
#include <ibus.h>
#include <stdlib.h>
#include <gio/gio.h>


#define TYPE_PREEDIT_STYLE (preedit_style_get_type ())

#define TYPE_OPTIONS (options_get_type ())
typedef struct _Options Options;

#define TYPE_CLIENT (client_get_type ())
#define CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLIENT, Client))
#define CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLIENT, ClientClass))
#define IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLIENT))
#define IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLIENT))
#define CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLIENT, ClientClass))

typedef struct _Client Client;
typedef struct _ClientClass ClientClass;
typedef struct _ClientPrivate ClientPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))

typedef enum  {
	PREEDIT_STYLE_OVER_THE_SPOT,
	PREEDIT_STYLE_ROOT,
	PREEDIT_STYLE_DEFAULT = PREEDIT_STYLE_OVER_THE_SPOT
} PreeditStyle;

struct _Options {
	PreeditStyle preedit_style;
};

struct _Client {
	FepGClient parent_instance;
	ClientPrivate * priv;
};

struct _ClientClass {
	FepGClientClass parent_class;
};

struct _ClientPrivate {
	IBusInputContext* context;
	IBusLookupTable* lookup_table;
	gboolean preedit_visible;
	gboolean lookup_table_visible;
	Options opts;
	gchar* preedit;
	FepGAttribute* preedit_attr;
	gchar* status;
	FepGAttribute* status_attr;
};

struct _Block1Data {
	int _ref_count_;
	Client* self;
	IBusBus* bus;
};


static gpointer client_parent_class = NULL;

GType preedit_style_get_type (void) G_GNUC_CONST;
GType options_get_type (void) G_GNUC_CONST;
Options* options_dup (const Options* self);
void options_free (Options* self);
GType client_get_type (void) G_GNUC_CONST;
#define CLIENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CLIENT, ClientPrivate))
enum  {
	CLIENT_DUMMY_PROPERTY
};
static void _client_ibus_commit_text (Client* self, IBusText* text);
static void _client_ibus_show_preedit_text (Client* self);
static FepGAttribute* _fep_g_attribute_dup (FepGAttribute* self);
static void _client_ibus_hide_preedit_text (Client* self);
static void client_update_status (Client* self);
static void _client_ibus_update_preedit_text (Client* self, IBusText* text, guint cursor_pos, gboolean visible);
static gboolean _fep_g_attribute_equal (const FepGAttribute* s1, const FepGAttribute* s2);
static gchar* client_format_indicator (Client* self);
static void _client_ibus_show_lookup_table (Client* self);
static void _client_ibus_hide_lookup_table (Client* self);
static void _client_ibus_update_lookup_table (Client* self, IBusLookupTable* lookup_table, gboolean visible);
static void _client_ibus_global_engine_changed (Client* self, const gchar* name);
static gboolean client_real_filter_key_event (FepGClient* base, guint keyval, guint modifiers);
static gboolean client_watch_func (Client* self, GIOChannel* source, GIOCondition condition);
static void client_create_input_context_done (Client* self);
static void __client_ibus_commit_text_ibus_input_context_commit_text (IBusInputContext* _sender, IBusText* p0, gpointer self);
static void __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text (IBusInputContext* _sender, gpointer self);
static void __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text (IBusInputContext* _sender, gpointer self);
static void __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text (IBusInputContext* _sender, IBusText* p0, guint p1, gboolean p2, gpointer self);
static void __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table (IBusInputContext* _sender, gpointer self);
static void __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table (IBusInputContext* _sender, gpointer self);
static void __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table (IBusInputContext* _sender, IBusLookupTable* p0, gboolean p1, gpointer self);
Client* client_new (IBusBus* bus, Options* opts, GError** error);
Client* client_construct (GType object_type, IBusBus* bus, Options* opts, GError** error);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __client_ibus_global_engine_changed_ibus_bus_global_engine_changed (IBusBus* _sender, const gchar* p0, gpointer self);
static void __lambda4_ (Block1Data* _data1_, GObject* obj, GAsyncResult* res);
static void ___lambda4__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static gboolean _client_watch_func_gio_func (GIOChannel* source, GIOCondition condition, gpointer self);
static void client_finalize (GObject* obj);


GType preedit_style_get_type (void) {
	static volatile gsize preedit_style_type_id__volatile = 0;
	if (g_once_init_enter (&preedit_style_type_id__volatile)) {
		static const GEnumValue values[] = {{PREEDIT_STYLE_OVER_THE_SPOT, "PREEDIT_STYLE_OVER_THE_SPOT", "over-the-spot"}, {PREEDIT_STYLE_ROOT, "PREEDIT_STYLE_ROOT", "root"}, {PREEDIT_STYLE_DEFAULT, "PREEDIT_STYLE_DEFAULT", "default"}, {0, NULL, NULL}};
		GType preedit_style_type_id;
		preedit_style_type_id = g_enum_register_static ("PreeditStyle", values);
		g_once_init_leave (&preedit_style_type_id__volatile, preedit_style_type_id);
	}
	return preedit_style_type_id__volatile;
}


Options* options_dup (const Options* self) {
	Options* dup;
	dup = g_new0 (Options, 1);
	memcpy (dup, self, sizeof (Options));
	return dup;
}


void options_free (Options* self) {
	g_free (self);
}


GType options_get_type (void) {
	static volatile gsize options_type_id__volatile = 0;
	if (g_once_init_enter (&options_type_id__volatile)) {
		GType options_type_id;
		options_type_id = g_boxed_type_register_static ("Options", (GBoxedCopyFunc) options_dup, (GBoxedFreeFunc) options_free);
		g_once_init_leave (&options_type_id__volatile, options_type_id);
	}
	return options_type_id__volatile;
}


static void _client_ibus_commit_text (Client* self, IBusText* text) {
	gchar* str = NULL;
	IBusText* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = text;
	_tmp1_ = ibus_text_get_text (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	str = _tmp2_;
	_tmp3_ = str;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ > 0) {
		const gchar* _tmp6_ = NULL;
		_tmp6_ = str;
		fep_g_client_send_text ((FepGClient*) self, _tmp6_);
	}
	_g_free0 (str);
}


static FepGAttribute* _fep_g_attribute_dup (FepGAttribute* self) {
	FepGAttribute* dup;
	dup = g_new0 (FepGAttribute, 1);
	memcpy (dup, self, sizeof (FepGAttribute));
	return dup;
}


static gpointer __fep_g_attribute_dup0 (gpointer self) {
	return self ? _fep_g_attribute_dup (self) : NULL;
}


static void _client_ibus_show_preedit_text (Client* self) {
	Options _tmp0_ = {0};
	PreeditStyle _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->opts;
	_tmp1_ = _tmp0_.preedit_style;
	if (_tmp1_ == PREEDIT_STYLE_ROOT) {
		const gchar* _tmp2_ = NULL;
		FepGAttribute* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		FepGAttribute* _tmp6_ = NULL;
		FepGAttribute* _tmp7_ = NULL;
		_tmp2_ = self->priv->preedit;
		_tmp3_ = self->priv->preedit_attr;
		fep_g_client_set_status_text ((FepGClient*) self, _tmp2_, _tmp3_);
		_tmp4_ = self->priv->preedit;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (self->priv->status);
		self->priv->status = _tmp5_;
		_tmp6_ = self->priv->preedit_attr;
		_tmp7_ = __fep_g_attribute_dup0 (_tmp6_);
		_g_free0 (self->priv->status_attr);
		self->priv->status_attr = _tmp7_;
	} else {
		const gchar* _tmp8_ = NULL;
		FepGAttribute* _tmp9_ = NULL;
		_tmp8_ = self->priv->preedit;
		_tmp9_ = self->priv->preedit_attr;
		fep_g_client_set_cursor_text ((FepGClient*) self, _tmp8_, _tmp9_);
	}
	self->priv->preedit_visible = TRUE;
}


static void _client_ibus_hide_preedit_text (Client* self) {
	Options _tmp0_ = {0};
	PreeditStyle _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->opts;
	_tmp1_ = _tmp0_.preedit_style;
	if (_tmp1_ == PREEDIT_STYLE_ROOT) {
		client_update_status (self);
	} else {
		fep_g_client_set_cursor_text ((FepGClient*) self, "", NULL);
	}
	self->priv->preedit_visible = FALSE;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean _fep_g_attribute_equal (const FepGAttribute* s1, const FepGAttribute* s2) {
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->type != s2->type) {
		return FALSE;
	}
	if (s1->value != s2->value) {
		return FALSE;
	}
	if (s1->start_index != s2->start_index) {
		return FALSE;
	}
	if (s1->end_index != s2->end_index) {
		return FALSE;
	}
	return TRUE;
}


static void _client_ibus_update_preedit_text (Client* self, IBusText* text, guint cursor_pos, gboolean visible) {
	gchar* _preedit = NULL;
	IBusText* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	IBusAttrList* attrs = NULL;
	IBusText* _tmp3_ = NULL;
	IBusAttrList* _tmp4_ = NULL;
	IBusAttrList* _tmp5_ = NULL;
	FepGAttribute* attr = NULL;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	const gchar* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = text;
	_tmp1_ = ibus_text_get_text (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	_preedit = _tmp2_;
	_tmp3_ = text;
	_tmp4_ = ibus_text_get_attributes (_tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	attrs = _tmp5_;
	attr = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_ = 0;
				IBusAttrList* _tmp9_ = NULL;
				GArray* _tmp10_ = NULL;
				guint _tmp11_ = 0U;
				IBusAttribute* _attr = NULL;
				IBusAttrList* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				IBusAttribute* _tmp14_ = NULL;
				IBusAttribute* _tmp15_ = NULL;
				IBusAttribute* _tmp16_ = NULL;
				guint _tmp17_ = 0U;
				if (!_tmp6_) {
					gint _tmp7_ = 0;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = attrs;
				_tmp10_ = _tmp9_->attributes;
				_tmp11_ = _tmp10_->len;
				if (!(((guint) _tmp8_) < _tmp11_)) {
					break;
				}
				_tmp12_ = attrs;
				_tmp13_ = i;
				_tmp14_ = ibus_attr_list_get (_tmp12_, (guint) _tmp13_);
				_tmp15_ = _g_object_ref0 (_tmp14_);
				_attr = _tmp15_;
				_tmp16_ = _attr;
				_tmp17_ = _tmp16_->type;
				if (_tmp17_ == ((guint) IBUS_ATTR_TYPE_UNDERLINE)) {
					IBusAttribute* _tmp18_ = NULL;
					guint _tmp19_ = 0U;
					IBusAttribute* _tmp20_ = NULL;
					guint _tmp21_ = 0U;
					FepGAttribute _tmp22_ = {0};
					FepGAttribute* _tmp23_ = NULL;
					_tmp18_ = _attr;
					_tmp19_ = _tmp18_->start_index;
					_tmp20_ = _attr;
					_tmp21_ = _tmp20_->end_index;
					memset (&_tmp22_, 0, sizeof (FepGAttribute));
					_tmp22_.type = FEP_G_ATTR_TYPE_UNDERLINE;
					_tmp22_.value = (guint) FEP_G_ATTR_UNDERLINE_SINGLE;
					_tmp22_.start_index = _tmp19_;
					_tmp22_.end_index = _tmp21_;
					_tmp23_ = __fep_g_attribute_dup0 (&_tmp22_);
					_g_free0 (attr);
					attr = _tmp23_;
				}
				_g_object_unref0 (_attr);
			}
		}
	}
	_tmp26_ = self->priv->preedit;
	_tmp27_ = _preedit;
	if (g_strcmp0 (_tmp26_, _tmp27_) != 0) {
		_tmp25_ = TRUE;
	} else {
		FepGAttribute* _tmp28_ = NULL;
		FepGAttribute* _tmp29_ = NULL;
		_tmp28_ = self->priv->preedit_attr;
		_tmp29_ = attr;
		_tmp25_ = _fep_g_attribute_equal (_tmp28_, _tmp29_) != TRUE;
	}
	if (_tmp25_) {
		_tmp24_ = TRUE;
	} else {
		gboolean _tmp30_ = FALSE;
		gboolean _tmp31_ = FALSE;
		_tmp30_ = self->priv->preedit_visible;
		_tmp31_ = visible;
		_tmp24_ = _tmp30_ != _tmp31_;
	}
	if (_tmp24_) {
		const gchar* _tmp32_ = NULL;
		gchar* _tmp33_ = NULL;
		FepGAttribute* _tmp34_ = NULL;
		FepGAttribute* _tmp35_ = NULL;
		gboolean _tmp36_ = FALSE;
		_tmp32_ = _preedit;
		_tmp33_ = g_strdup (_tmp32_);
		_g_free0 (self->priv->preedit);
		self->priv->preedit = _tmp33_;
		_tmp34_ = attr;
		_tmp35_ = __fep_g_attribute_dup0 (_tmp34_);
		_g_free0 (self->priv->preedit_attr);
		self->priv->preedit_attr = _tmp35_;
		_tmp36_ = visible;
		if (_tmp36_) {
			_client_ibus_show_preedit_text (self);
		} else {
			_client_ibus_hide_preedit_text (self);
		}
	}
	_g_free0 (attr);
	_g_object_unref0 (attrs);
	_g_free0 (_preedit);
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_ = 0L;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_ = 0L;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		_tmp3_ = offset;
		_tmp4_ = len;
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
		string_length = _tmp5_;
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp6_ = strlen (self);
		_tmp7_ = _tmp6_;
		string_length = (glong) _tmp7_;
	}
	_tmp8_ = offset;
	if (_tmp8_ < ((glong) 0)) {
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp9_ = string_length;
		_tmp10_ = offset;
		offset = _tmp9_ + _tmp10_;
		_tmp11_ = offset;
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
		_tmp12_ = offset;
		_tmp13_ = string_length;
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
	}
	_tmp14_ = len;
	if (_tmp14_ < ((glong) 0)) {
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
		_tmp15_ = string_length;
		_tmp16_ = offset;
		len = _tmp15_ - _tmp16_;
	}
	_tmp17_ = offset;
	_tmp18_ = len;
	_tmp19_ = string_length;
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
	_tmp20_ = offset;
	_tmp21_ = len;
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
	result = _tmp22_;
	return result;
}


static gchar* client_format_indicator (Client* self) {
	gchar* result = NULL;
	IBusEngineDesc* desc = NULL;
	IBusInputContext* _tmp0_ = NULL;
	IBusEngineDesc* _tmp1_ = NULL;
	IBusEngineDesc* _tmp2_ = NULL;
	IBusEngineDesc* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = ibus_input_context_get_engine (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	desc = _tmp2_;
	_tmp3_ = desc;
	if (_tmp3_ != NULL) {
		gchar* symbol = NULL;
		IBusEngineDesc* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		_tmp4_ = desc;
		_tmp5_ = ibus_engine_desc_get_symbol (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strdup (_tmp6_);
		symbol = _tmp7_;
		_tmp8_ = symbol;
		_tmp9_ = strlen (_tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp10_ == 0) {
			IBusEngineDesc* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
			gchar* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
			_tmp11_ = desc;
			_tmp12_ = ibus_engine_desc_get_name (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_utf8_strup (_tmp13_, (gssize) (-1));
			_tmp15_ = _tmp14_;
			_tmp16_ = g_strconcat (_tmp15_, "??", NULL);
			_tmp17_ = _tmp16_;
			_tmp18_ = string_substring (_tmp17_, (glong) 0, (glong) 2);
			_g_free0 (symbol);
			symbol = _tmp18_;
			_g_free0 (_tmp17_);
			_g_free0 (_tmp15_);
		}
		_tmp19_ = symbol;
		_tmp20_ = g_strconcat ("[", _tmp19_, NULL);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strconcat (_tmp21_, "] ", NULL);
		_tmp23_ = _tmp22_;
		_g_free0 (_tmp21_);
		result = _tmp23_;
		_g_free0 (symbol);
		_g_object_unref0 (desc);
		return result;
	} else {
		gchar* _tmp24_ = NULL;
		_tmp24_ = g_strdup ("[??] ");
		result = _tmp24_;
		_g_object_unref0 (desc);
		return result;
	}
	_g_object_unref0 (desc);
}


static void client_update_status (Client* self) {
	GString* builder = NULL;
	GString* _tmp0_ = NULL;
	GString* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	FepGAttribute* attr = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp65_ = FALSE;
	const gchar* _tmp66_ = NULL;
	GString* _tmp67_ = NULL;
	const gchar* _tmp68_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	_tmp1_ = builder;
	_tmp2_ = client_format_indicator (self);
	_tmp3_ = _tmp2_;
	g_string_append (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	attr = NULL;
	_tmp4_ = self->priv->lookup_table_visible;
	if (_tmp4_) {
		guint pages = 0U;
		IBusLookupTable* _tmp5_ = NULL;
		guint _tmp6_ = 0U;
		IBusLookupTable* _tmp7_ = NULL;
		guint _tmp8_ = 0U;
		guint start = 0U;
		guint _tmp9_ = 0U;
		IBusLookupTable* _tmp10_ = NULL;
		guint _tmp11_ = 0U;
		guint end = 0U;
		guint _tmp12_ = 0U;
		IBusLookupTable* _tmp13_ = NULL;
		guint _tmp14_ = 0U;
		IBusLookupTable* _tmp15_ = NULL;
		guint _tmp16_ = 0U;
		guint _tmp17_ = 0U;
		_tmp5_ = self->priv->lookup_table;
		_tmp6_ = _tmp5_->cursor_pos;
		_tmp7_ = self->priv->lookup_table;
		_tmp8_ = _tmp7_->page_size;
		pages = _tmp6_ / _tmp8_;
		_tmp9_ = pages;
		_tmp10_ = self->priv->lookup_table;
		_tmp11_ = _tmp10_->page_size;
		start = _tmp9_ * _tmp11_;
		_tmp12_ = start;
		_tmp13_ = self->priv->lookup_table;
		_tmp14_ = _tmp13_->page_size;
		_tmp15_ = self->priv->lookup_table;
		_tmp16_ = ibus_lookup_table_get_number_of_candidates (_tmp15_);
		_tmp17_ = MIN (_tmp12_ + _tmp14_, _tmp16_);
		end = _tmp17_;
		{
			guint index = 0U;
			guint _tmp18_ = 0U;
			_tmp18_ = start;
			index = _tmp18_;
			{
				gboolean _tmp19_ = FALSE;
				_tmp19_ = TRUE;
				while (TRUE) {
					guint _tmp21_ = 0U;
					guint _tmp22_ = 0U;
					IBusText* label = NULL;
					IBusLookupTable* _tmp23_ = NULL;
					guint _tmp24_ = 0U;
					guint _tmp25_ = 0U;
					IBusText* _tmp26_ = NULL;
					IBusText* _tmp27_ = NULL;
					IBusText* candidate = NULL;
					IBusLookupTable* _tmp28_ = NULL;
					guint _tmp29_ = 0U;
					IBusText* _tmp30_ = NULL;
					IBusText* _tmp31_ = NULL;
					gchar* _tmp32_ = NULL;
					IBusText* _tmp33_ = NULL;
					gchar* label_text = NULL;
					gchar* _tmp40_ = NULL;
					gchar* text = NULL;
					const gchar* _tmp41_ = NULL;
					IBusText* _tmp42_ = NULL;
					const gchar* _tmp43_ = NULL;
					gchar* _tmp44_ = NULL;
					gboolean _tmp45_ = FALSE;
					IBusLookupTable* _tmp46_ = NULL;
					gboolean _tmp47_ = FALSE;
					GString* _tmp60_ = NULL;
					const gchar* _tmp61_ = NULL;
					guint _tmp62_ = 0U;
					guint _tmp63_ = 0U;
					if (!_tmp19_) {
						guint _tmp20_ = 0U;
						_tmp20_ = index;
						index = _tmp20_ + 1;
					}
					_tmp19_ = FALSE;
					_tmp21_ = index;
					_tmp22_ = end;
					if (!(_tmp21_ < _tmp22_)) {
						break;
					}
					_tmp23_ = self->priv->lookup_table;
					_tmp24_ = index;
					_tmp25_ = start;
					_tmp26_ = ibus_lookup_table_get_label (_tmp23_, _tmp24_ - _tmp25_);
					_tmp27_ = _g_object_ref0 (_tmp26_);
					label = _tmp27_;
					_tmp28_ = self->priv->lookup_table;
					_tmp29_ = index;
					_tmp30_ = ibus_lookup_table_get_candidate (_tmp28_, _tmp29_);
					_tmp31_ = _g_object_ref0 (_tmp30_);
					candidate = _tmp31_;
					_tmp33_ = label;
					if (_tmp33_ != NULL) {
						IBusText* _tmp34_ = NULL;
						const gchar* _tmp35_ = NULL;
						gchar* _tmp36_ = NULL;
						_tmp34_ = label;
						_tmp35_ = ibus_text_get_text (_tmp34_);
						_tmp36_ = g_strdup (_tmp35_);
						_g_free0 (_tmp32_);
						_tmp32_ = _tmp36_;
					} else {
						guint _tmp37_ = 0U;
						guint _tmp38_ = 0U;
						gchar* _tmp39_ = NULL;
						_tmp37_ = index;
						_tmp38_ = start;
						_tmp39_ = g_strdup_printf ("%u", (_tmp37_ - _tmp38_) + 1);
						_g_free0 (_tmp32_);
						_tmp32_ = _tmp39_;
					}
					_tmp40_ = g_strdup (_tmp32_);
					label_text = _tmp40_;
					_tmp41_ = label_text;
					_tmp42_ = candidate;
					_tmp43_ = ibus_text_get_text (_tmp42_);
					_tmp44_ = g_strdup_printf ("%s:%s", _tmp41_, _tmp43_);
					text = _tmp44_;
					_tmp46_ = self->priv->lookup_table;
					_tmp47_ = ibus_lookup_table_is_cursor_visible (_tmp46_);
					if (_tmp47_) {
						guint _tmp48_ = 0U;
						IBusLookupTable* _tmp49_ = NULL;
						guint _tmp50_ = 0U;
						_tmp48_ = index;
						_tmp49_ = self->priv->lookup_table;
						_tmp50_ = ibus_lookup_table_get_cursor_pos (_tmp49_);
						_tmp45_ = _tmp48_ == _tmp50_;
					} else {
						_tmp45_ = FALSE;
					}
					if (_tmp45_) {
						gint start_index = 0;
						GString* _tmp51_ = NULL;
						const gchar* _tmp52_ = NULL;
						gint _tmp53_ = 0;
						gint _tmp54_ = 0;
						gint _tmp55_ = 0;
						const gchar* _tmp56_ = NULL;
						gint _tmp57_ = 0;
						FepGAttribute _tmp58_ = {0};
						FepGAttribute* _tmp59_ = NULL;
						_tmp51_ = builder;
						_tmp52_ = _tmp51_->str;
						_tmp53_ = g_utf8_strlen (_tmp52_, (gssize) (-1));
						start_index = _tmp53_;
						_tmp54_ = start_index;
						_tmp55_ = start_index;
						_tmp56_ = text;
						_tmp57_ = g_utf8_strlen (_tmp56_, (gssize) (-1));
						memset (&_tmp58_, 0, sizeof (FepGAttribute));
						_tmp58_.type = FEP_G_ATTR_TYPE_STANDOUT;
						_tmp58_.value = (guint) 1;
						_tmp58_.start_index = (guint) _tmp54_;
						_tmp58_.end_index = (guint) (_tmp55_ + _tmp57_);
						_tmp59_ = __fep_g_attribute_dup0 (&_tmp58_);
						_g_free0 (attr);
						attr = _tmp59_;
					}
					_tmp60_ = builder;
					_tmp61_ = text;
					g_string_append (_tmp60_, _tmp61_);
					_tmp62_ = index;
					_tmp63_ = end;
					if (_tmp62_ < (_tmp63_ - 1)) {
						GString* _tmp64_ = NULL;
						_tmp64_ = builder;
						g_string_append_c (_tmp64_, ' ');
					}
					_g_free0 (text);
					_g_free0 (label_text);
					_g_free0 (_tmp32_);
					_g_object_unref0 (candidate);
					_g_object_unref0 (label);
				}
			}
		}
	}
	_tmp66_ = self->priv->status;
	_tmp67_ = builder;
	_tmp68_ = _tmp67_->str;
	if (g_strcmp0 (_tmp66_, _tmp68_) != 0) {
		_tmp65_ = TRUE;
	} else {
		FepGAttribute* _tmp69_ = NULL;
		FepGAttribute* _tmp70_ = NULL;
		_tmp69_ = self->priv->status_attr;
		_tmp70_ = attr;
		_tmp65_ = _fep_g_attribute_equal (_tmp69_, _tmp70_) != TRUE;
	}
	if (_tmp65_) {
		GString* _tmp71_ = NULL;
		const gchar* _tmp72_ = NULL;
		FepGAttribute* _tmp73_ = NULL;
		GString* _tmp74_ = NULL;
		const gchar* _tmp75_ = NULL;
		gchar* _tmp76_ = NULL;
		FepGAttribute* _tmp77_ = NULL;
		FepGAttribute* _tmp78_ = NULL;
		_tmp71_ = builder;
		_tmp72_ = _tmp71_->str;
		_tmp73_ = attr;
		fep_g_client_set_status_text ((FepGClient*) self, _tmp72_, _tmp73_);
		_tmp74_ = builder;
		_tmp75_ = _tmp74_->str;
		_tmp76_ = g_strdup (_tmp75_);
		_g_free0 (self->priv->status);
		self->priv->status = _tmp76_;
		_tmp77_ = attr;
		_tmp78_ = __fep_g_attribute_dup0 (_tmp77_);
		_g_free0 (self->priv->status_attr);
		self->priv->status_attr = _tmp78_;
	}
	_g_free0 (attr);
	_g_string_free0 (builder);
}


static void _client_ibus_show_lookup_table (Client* self) {
	g_return_if_fail (self != NULL);
	self->priv->lookup_table_visible = TRUE;
	client_update_status (self);
}


static void _client_ibus_hide_lookup_table (Client* self) {
	gboolean _tmp0_ = FALSE;
	Options _tmp1_ = {0};
	PreeditStyle _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	self->priv->lookup_table_visible = FALSE;
	_tmp1_ = self->priv->opts;
	_tmp2_ = _tmp1_.preedit_style;
	if (_tmp2_ == PREEDIT_STYLE_ROOT) {
		gboolean _tmp3_ = FALSE;
		_tmp3_ = self->priv->preedit_visible;
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		_client_ibus_show_preedit_text (self);
	} else {
		client_update_status (self);
	}
}


static void _client_ibus_update_lookup_table (Client* self, IBusLookupTable* lookup_table, gboolean visible) {
	IBusLookupTable* _tmp0_ = NULL;
	IBusLookupTable* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (lookup_table != NULL);
	_tmp0_ = lookup_table;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->lookup_table);
	self->priv->lookup_table = _tmp1_;
	_tmp2_ = visible;
	if (_tmp2_) {
		_client_ibus_show_lookup_table (self);
	} else {
		_client_ibus_hide_lookup_table (self);
	}
}


static void _client_ibus_global_engine_changed (Client* self, const gchar* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	client_update_status (self);
}


static gboolean client_real_filter_key_event (FepGClient* base, guint keyval, guint modifiers) {
	Client * self;
	gboolean result = FALSE;
	IBusInputContext* _tmp0_ = NULL;
	self = (Client*) base;
	_tmp0_ = self->priv->context;
	if (_tmp0_ != NULL) {
		gboolean retval = FALSE;
		IBusInputContext* _tmp1_ = NULL;
		guint _tmp2_ = 0U;
		guint _tmp3_ = 0U;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		_tmp1_ = self->priv->context;
		_tmp2_ = keyval;
		_tmp3_ = modifiers;
		_tmp4_ = ibus_input_context_process_key_event (_tmp1_, (guint32) _tmp2_, (guint32) 0, (guint32) _tmp3_);
		retval = _tmp4_;
		_tmp5_ = retval;
		if (_tmp5_) {
			client_update_status (self);
		}
		result = retval;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean client_watch_func (Client* self, GIOChannel* source, GIOCondition condition) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	fep_g_client_dispatch ((FepGClient*) self);
	result = TRUE;
	return result;
}


static void __client_ibus_commit_text_ibus_input_context_commit_text (IBusInputContext* _sender, IBusText* p0, gpointer self) {
	_client_ibus_commit_text ((Client*) self, p0);
}


static void __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text (IBusInputContext* _sender, gpointer self) {
	_client_ibus_show_preedit_text ((Client*) self);
}


static void __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text (IBusInputContext* _sender, gpointer self) {
	_client_ibus_hide_preedit_text ((Client*) self);
}


static void __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text (IBusInputContext* _sender, IBusText* p0, guint p1, gboolean p2, gpointer self) {
	_client_ibus_update_preedit_text ((Client*) self, p0, p1, p2);
}


static void __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table (IBusInputContext* _sender, gpointer self) {
	_client_ibus_show_lookup_table ((Client*) self);
}


static void __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table (IBusInputContext* _sender, gpointer self) {
	_client_ibus_hide_lookup_table ((Client*) self);
}


static void __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table (IBusInputContext* _sender, IBusLookupTable* p0, gboolean p1, gpointer self) {
	_client_ibus_update_lookup_table ((Client*) self, p0, p1);
}


static void client_create_input_context_done (Client* self) {
	IBusInputContext* _tmp0_ = NULL;
	IBusInputContext* _tmp1_ = NULL;
	IBusInputContext* _tmp2_ = NULL;
	IBusInputContext* _tmp3_ = NULL;
	IBusInputContext* _tmp4_ = NULL;
	IBusInputContext* _tmp5_ = NULL;
	IBusInputContext* _tmp6_ = NULL;
	IBusInputContext* _tmp7_ = NULL;
	IBusInputContext* _tmp8_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	g_signal_connect_object (_tmp0_, "commit-text", (GCallback) __client_ibus_commit_text_ibus_input_context_commit_text, self, 0);
	_tmp1_ = self->priv->context;
	g_signal_connect_object (_tmp1_, "show-preedit-text", (GCallback) __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text, self, 0);
	_tmp2_ = self->priv->context;
	g_signal_connect_object (_tmp2_, "hide-preedit-text", (GCallback) __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text, self, 0);
	_tmp3_ = self->priv->context;
	g_signal_connect_object (_tmp3_, "update-preedit-text", (GCallback) __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text, self, 0);
	_tmp4_ = self->priv->context;
	g_signal_connect_object (_tmp4_, "show-lookup-table", (GCallback) __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table, self, 0);
	_tmp5_ = self->priv->context;
	g_signal_connect_object (_tmp5_, "hide-lookup-table", (GCallback) __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table, self, 0);
	_tmp6_ = self->priv->context;
	g_signal_connect_object (_tmp6_, "update-lookup-table", (GCallback) __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table, self, 0);
	_tmp7_ = self->priv->context;
	ibus_input_context_set_capabilities (_tmp7_, (guint32) (((IBUS_CAP_PREEDIT_TEXT | IBUS_CAP_LOOKUP_TABLE) | IBUS_CAP_AUXILIARY_TEXT) | IBUS_CAP_FOCUS));
	_tmp8_ = self->priv->context;
	ibus_input_context_focus_in (_tmp8_);
	client_update_status (self);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		Client* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->bus);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static void __client_ibus_global_engine_changed_ibus_bus_global_engine_changed (IBusBus* _sender, const gchar* p0, gpointer self) {
	_client_ibus_global_engine_changed ((Client*) self, p0);
}


static void __lambda4_ (Block1Data* _data1_, GObject* obj, GAsyncResult* res) {
	Client* self;
	GError * _inner_error_ = NULL;
	self = _data1_->self;
	g_return_if_fail (res != NULL);
	{
		IBusInputContext* _tmp0_ = NULL;
		IBusBus* _tmp1_ = NULL;
		GAsyncResult* _tmp2_ = NULL;
		IBusInputContext* _tmp3_ = NULL;
		IBusInputContext* _tmp4_ = NULL;
		_tmp1_ = _data1_->bus;
		_tmp2_ = res;
		_tmp3_ = ibus_bus_create_input_context_async_finish (_tmp1_, _tmp2_, &_inner_error_);
		_tmp0_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->context);
		self->priv->context = _tmp4_;
		client_create_input_context_done (self);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("client.vala:263: can't create input context: %s", _tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda4__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	__lambda4_ (self, source_object, res);
	block1_data_unref (self);
}


static gboolean _client_watch_func_gio_func (GIOChannel* source, GIOCondition condition, gpointer self) {
	gboolean result;
	result = client_watch_func ((Client*) self, source, condition);
	return result;
}


Client* client_construct (GType object_type, IBusBus* bus, Options* opts, GError** error) {
	Client * self = NULL;
	Block1Data* _data1_;
	IBusBus* _tmp0_ = NULL;
	IBusBus* _tmp1_ = NULL;
	Options _tmp2_ = {0};
	IBusBus* _tmp3_ = NULL;
	IBusBus* _tmp4_ = NULL;
	GIOChannel* channel = NULL;
	gint _tmp5_ = 0;
	GIOChannel* _tmp6_ = NULL;
	GIOChannel* _tmp7_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (bus != NULL, NULL);
	g_return_val_if_fail (opts != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = bus;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data1_->bus);
	_data1_->bus = _tmp1_;
	self = (Client*) g_object_new (object_type, "address", NULL, NULL);
	_data1_->self = g_object_ref (self);
	g_initable_init ((GInitable*) self, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		_g_object_unref0 (self);
		return NULL;
	}
	_tmp2_ = *opts;
	self->priv->opts = _tmp2_;
	_tmp3_ = _data1_->bus;
	g_signal_connect_object (_tmp3_, "global-engine-changed", (GCallback) __client_ibus_global_engine_changed_ibus_bus_global_engine_changed, self, 0);
	_tmp4_ = _data1_->bus;
	ibus_bus_create_input_context_async (_tmp4_, "ibus-fep", -1, NULL, ___lambda4__gasync_ready_callback, block1_data_ref (_data1_));
	_tmp5_ = fep_g_client_get_poll_fd ((FepGClient*) self);
	_tmp6_ = g_io_channel_unix_new (_tmp5_);
	channel = _tmp6_;
	_tmp7_ = channel;
	g_io_add_watch (_tmp7_, G_IO_IN, _client_watch_func_gio_func, self);
	_g_io_channel_unref0 (channel);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return self;
}


Client* client_new (IBusBus* bus, Options* opts, GError** error) {
	return client_construct (TYPE_CLIENT, bus, opts, error);
}


static void client_class_init (ClientClass * klass) {
	client_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ClientPrivate));
	((FepGClientClass *) klass)->filter_key_event = client_real_filter_key_event;
	G_OBJECT_CLASS (klass)->finalize = client_finalize;
}


static void client_instance_init (Client * self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	self->priv = CLIENT_GET_PRIVATE (self);
	self->priv->context = NULL;
	self->priv->preedit_visible = FALSE;
	self->priv->lookup_table_visible = FALSE;
	_tmp0_ = g_strdup ("");
	self->priv->preedit = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->status = _tmp1_;
}


static void client_finalize (GObject* obj) {
	Client * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLIENT, Client);
	_g_object_unref0 (self->priv->context);
	_g_object_unref0 (self->priv->lookup_table);
	_g_free0 (self->priv->preedit);
	_g_free0 (self->priv->preedit_attr);
	_g_free0 (self->priv->status);
	_g_free0 (self->priv->status_attr);
	G_OBJECT_CLASS (client_parent_class)->finalize (obj);
}


GType client_get_type (void) {
	static volatile gsize client_type_id__volatile = 0;
	if (g_once_init_enter (&client_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Client), 0, (GInstanceInitFunc) client_instance_init, NULL };
		GType client_type_id;
		client_type_id = g_type_register_static (fep_g_client_get_type (), "Client", &g_define_type_info, 0);
		g_once_init_leave (&client_type_id__volatile, client_type_id);
	}
	return client_type_id__volatile;
}



